﻿using HarmonyLib;
using System.Reflection;
using UnityEngine;

public class TurnYourRaft : Mod
{
    Harmony harmonyInstance;
    string harmonyId = "fr.tekgamer.turnyourraft";

    public void Start()
    {
        harmonyInstance = new Harmony(harmonyId);
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());
    }

    public void OnModUnload()
    {
        harmonyInstance.UnpatchAll(harmonyId);
        Debug.Log("TurnYourRaft has been unloaded!");
    }
}

[HarmonyPatch(typeof(Paddle))]
[HarmonyPatch("PaddlePaddle")]
public static class Paddle_PaddlePaddle_Patch
{
    private static void Prefix()
    {
        if (Semih_Network.IsHost)
        {
            int direction;
            if (Input.GetKey(KeyCode.LeftArrow))
            {
                direction = -1;
            }
            else
            {
                if (!Input.GetKey(KeyCode.RightArrow))
                {
                    return;
                }
                direction = 1;
            }
            float directionFix = 0.14f;
            directionFix *= (float)direction;
            Raft raft = ComponentManager<Raft>.Value;
            Rigidbody rigidbody = Traverse.Create(raft).Field("body").GetValue() as Rigidbody;
            rigidbody.angularDrag = 0.8f;
            rigidbody.AddTorque(raft.transform.up * directionFix, ForceMode.VelocityChange);
        }
    }
}